#include "constants.h"
#include "planche.h"
#include "conteneurPlanche.h"
#include "sparam.h"

conteneurPlanche::conteneurPlanche()
{

 //setFocusPolicy(QWidget::StrongFocus) ;

 _scrollview = new QScrollView( this ) ;

 _planche = new planche(this,"_planche",0) ;
 _scrollview->addChild( _planche ) ;


  QObject::connect( _planche,SIGNAL(signalRepartitionMinMaxChanged(int*,int,int)),
 			this,SLOT(slotRepartitionMinMaxChanged(int*,int,int))) ;
  QObject::connect( _planche,SIGNAL(signalFrameChanged(double,double,double,double)),
 			this,SLOT(slotFrameChanged(double,double,double,double))) ;
  QObject::connect( _planche,SIGNAL(signalDelay(double)),this,SLOT(slotDelay(double)) ) ;
 show() ;
 _planche->show() ;

}

conteneurPlanche :: ~conteneurPlanche() {}

void conteneurPlanche :: slotDelay(double a) { emit signalDelay(a) ; }
void conteneurPlanche :: changeAlgorithmColoration(int a) { _planche->changeAlgorithmColoration(a) ; }
void conteneurPlanche :: changeEffect(int a) { _planche->changeEffect(a) ; }
void conteneurPlanche :: changeEffectColor(int a) { _planche->changeEffectColor(a) ; }
void conteneurPlanche :: calculateF9(double a,double b,double c,double d,int e,int f) { _planche->calculateF9(a,b,c,d,e,f) ; }
void conteneurPlanche :: changeIFS(paralleVector* p,int a,int b) { _planche->changeIFS(p,a,b) ; }
void conteneurPlanche :: getRepartition(int* t,int m,int M) { _planche->calculateRepartition(t,m,M ) ; }
void conteneurPlanche :: changeParameterColoration(parameterColoration* p)  { _planche->changeParameterColoration(p) ; }
void conteneurPlanche :: drawMatrix() { _planche->drawMatrix() ; }
void conteneurPlanche :: changeIterationAndGerms(int a,int b){ _planche->changeIterationAndGerms(a,b) ;} ;
void conteneurPlanche :: draw3D(double a,double b,double c,double d,double e,double f,int g,int gbis,QString h)
{ _planche->draw3D(a,b,c,d,e,f,g,gbis,h) ; }
void conteneurPlanche :: slotFrameChanged(double a,double b,double c,double d) { emit signalFrameChanged(a,b,c,d) ; }
void conteneurPlanche :: slotRepartitionMinMaxChanged(int* a,int b,int c)
{ emit signalRepartitionMinMaxChanged(a,b,c) ; }
void conteneurPlanche :: changeCoordinate(double a,double b,double c,double d) { _planche->changeCoordinate(a,b,c,d) ; }
void conteneurPlanche :: changeParameterEffectColor(sparam* s) { _planche->changeParameterEffectColor(s) ; }
void conteneurPlanche :: changeParameterEffect(sparam* s) { _planche->changeParameterEffect(s) ; }
void conteneurPlanche :: changeSizeMatrix(int s) { _planche->changeSizeMatrix(s) ; }
void conteneurPlanche :: loadPalette(QString f) { _planche->loadPalette(f) ; }
paletteRGB* conteneurPlanche :: getPalette() { return _planche->getPalette() ;}
void conteneurPlanche :: saveImage(QString f) { _planche->saveImage(f)  ; }
void conteneurPlanche :: resizeEvent(QResizeEvent* e ) {  _scrollview->setGeometry(0,0,width(),height()) ; }







