#ifndef CONTENEURPLANCHE_H
#define CONTENEURPLANCHE_H

using namespace std ;

#include <iostream>
#include <cmath>

#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qstring.h>

#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
//#include <qslider.h>
#include <qcombobox.h>
#include <qscrollview.h>

#include "constants.h"
class planche ;
class sparam ;

class conteneurPlanche : public QWidget
{
    Q_OBJECT

 public :
    conteneurPlanche();
    ~conteneurPlanche();
    void getRepartition(int* ,int,int) ;
    void changeCoordinate(double,double,double,double) ;
    void changeSizeMatrix(int) ;
    void loadPalette(QString) ;
    void changeParameterColoration(parameterColoration*) ;
    void drawMatrix() ;
    void changeAlgorithmColoration(int) ;
    //void getPalette(unsigned int**,int*) ;
    //void getPalette(int*) ;
    paletteRGB* getPalette() ;
    void saveImage(QString) ;
    void draw3D(double,double,double,double,double,double,int,int,QString) ;
    void changeIFS(paralleVector*,int,int ) ;
    void calculateF9(double,double,double,double,int,int) ;
    void changeIterationAndGerms(int,int ) ;
    void changeEffect(int) ;
    void changeEffectColor(int) ;
    //void changeKappa(double) ;
    void changeParameterEffectColor(sparam*) ;
    void changeParameterEffect(sparam*) ;

 signals :
    void signalFrameChanged( double,double,double,double ) ;
    void signalRepartitionMinMaxChanged(int*,int,int) ;
    void signalDelay(double) ;

 private slots :
    void slotDelay(double) ;
    void slotFrameChanged( double,double,double,double ) ;
    void slotRepartitionMinMaxChanged( int*,int,int ) ;

 protected :
    virtual void resizeEvent(QResizeEvent* ) ;

 private :

    QScrollView* _scrollview ;
    planche* _planche ;
};

#endif

