#include "effectColorContrast.h"
#include "constants.h"
#include "conversionSpaceColor.h"
#include "sparam.h"
#include "planche.h"

effectColorContrast :: effectColorContrast()
{
 intensity = 0.2 ;
 theta = 45.0*PII/180.0 ;
 phi = 45.0*PII/180.0 ;
}

effectColorContrast :: ~effectColorContrast()
{
}

void effectColorContrast :: setParameters(sparam* p)
{
 QString aux ;
 bool ok ;

 cout << " effectColorContrast :: setParameters(sparam* p) " << endl ;
 //cout << " intensity = " << (*p)[0] << endl ;
 intensity = (*p)[0].toDouble(&ok) ;
 if (not(ok)) intensity = 0.2 ;
 theta = (*p)[1].toInt(&ok) ;
 if (not(ok)) theta = 45.0 ;
 theta *= PII/180.0 ;
 phi = (*p)[2].toInt(&ok) ;
 if (not(ok)) phi = 45.0 ;
 phi *= PII/180.0 ;
 /*
 aux = (*p)[3] ;
 if (aux = "linear") typeZ = 0 ;
 return ;
 if (aux = "log") typeZ = 1 ;
 return ;
 if (aux = "loglog") typeZ = 2 ; else typeZ = 0 ;
 */
}

void effectColorContrast :: streamParameters( QTextStream& st )
{
}

void effectColorContrast :: calculate( planche* pl )
{
 double h,s,v,aEclair,bEclair,cEclair,z1,z2,z3,aa,bb,cosinus,Aux ;
 int i,j,b,sizeDecr,size2,size,mini,maxi ;
 int* m ;
 unsigned int* mc ;

 cout << " void effectColorContrast :: calculate( planche* pl ) " << endl ;

 aEclair = cos(theta)*cos(phi);
 bEclair = cos(theta)*sin(phi);
 cEclair = sin(theta);
 size = pl->getSize() ;
 sizeDecr = size - 1 ;
 m = pl->getMatrixLong() ;
 mc = pl->getMatrixColor() ;
 pl->getMinMax(&mini,&maxi) ;

 for(i = 0 ; i < sizeDecr ; i++)
	for( j=0 ; j < sizeDecr ; j++ )
		{
		 z1 = m[i*size+j] ;
		 z2 = m[i*size+j+1] ;
		 z3 = m[i*size+j+size] ;
		 aa = z1-z2 ;
		 bb = z1-z3 ;
		 Aux = sqrt(aa*aa+bb*bb+0.1);
		 cosinus = (aa*aEclair+bb*bEclair+cEclair)/Aux;
		 b = mc[i*size+j] ;
		 rgb2hsv(&h,&s,&v,b ) ;
		 s += intensity*cosinus ;
		 if (s > 1.0) s = 1.0 ;
		 if (s < 0.0) s = 0.0 ;
		 mc[i*size+j] = hsv2rgb(h,s,v) ;
		}
 size2 = size * sizeDecr ;
 for( j=0 ; j < sizeDecr ; j++ )
	{
	 z1 = m[size2+j] ;
	 z2 = m[size2+j+1] ;
	 z3 = m[size2-size+j] ;
	 aa = z3-z1 ;
	 bb = z1-z2 ;
	 Aux = sqrt(aa*aa+bb*bb+0.1);
	 cosinus = (aa*aEclair+bb*bEclair+cEclair)/Aux;
	 b = mc[size2+j] ;
	 rgb2hsv(&h,&s,&v,b ) ;
	 s += intensity*cosinus ;
	 if (s > 1.0) s = 1.0 ;
	 if (s < 0.0) s = 0.0 ;
	 mc[i*size+j] = hsv2rgb(h,s,v) ;
	}
 for(i = 0 ; i < sizeDecr ; i++)
	{
	 z1 = m[size*i+sizeDecr] ;
	 z2 = m[size*i+sizeDecr-1] ;
	 z3 = m[size*i+size+j] ;
	 aa = z2-z1 ;
	 bb = z1-z3 ;
	 Aux = sqrt(aa*aa+bb*bb+0.1);
	 cosinus = (aa*aEclair+bb*bEclair+cEclair)/Aux;
	 b = mc[size*i+sizeDecr] ;
	 rgb2hsv(&h,&s,&v,b ) ;
	 s += intensity*cosinus ;
	 if (s > 1.0) s = 1.0 ;
	 if (s < 0.0) s = 0.0 ;
	 mc[i*size+j] = hsv2rgb(h,s,v) ;
	}
 z1 = m[size2+sizeDecr] ;
 z2 = m[size2+sizeDecr-1] ;
 z3 = m[size2+1] ;
 aa = z3-z1 ;
 bb = z2-z1 ;
 Aux = sqrt(aa*aa+bb*bb+0.1);
 cosinus = (aa*aEclair+bb*bEclair+cEclair)/Aux;
 b = mc[size2+sizeDecr] ;
 rgb2hsv(&h,&s,&v,b ) ;
 s += intensity*cosinus ;
 if (s > 1.0) s = 1.0 ;
 if (s < 0.0) s = 0.0 ;
 mc[i*size+j] = hsv2rgb(h,s,v) ;
}




