#include "effectColorGamma.h"
#include "conversionSpaceColor.h"
#include "sparam.h"
#include "planche.h"

effectColorGamma :: effectColorGamma()
{
 k = 1.01 ;
 N = 20 ;
 inversed = 0 ;
}

effectColorGamma :: ~effectColorGamma()
{
}

void effectColorGamma :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) k = 1.01 ;
 N = (*p)[1].toInt(&ok) ;
 if (not(ok)) N = 20 ;
 inversed = (*p)[2].toInt(&ok) ;
 if (not(ok)) inversed = 0 ;

 //cout << "@ k = " << k  << endl ;
 //cout << "@ N = " << N  << endl ;
 //cout << "@ inversed = " << inversed  << endl ;
}

void effectColorGamma :: streamParameters( QTextStream& st )
{
}

void effectColorGamma :: calculate( planche* pl )
{
// cout << " void effectColorGamma :: calculate( planche* pl ) " << endl ;

 double h,s,v ;
 int i,j,minl,maxl,a,dl,b,o,size ;
 int* m ;
 unsigned int* mc ;


 size = pl->getSize() ;
 m = pl->getMatrixLong() ;
 mc = pl->getMatrixColor() ;
 pl->getMinMax(&minl,&maxl) ;

 dl = maxl-minl ;
 if (dl==0) dl = 1 ;

 if (inversed==0)
	{
	 for(i = 0 ; i < size ; i++)
		for( j=0 ; j < size ; j++ )
			{
			 a = m[i*size+j] ;
			 b = mc[i*size+j] ;
			 a = ((a-minl) * N) / dl ;
			 rgb2hsv(&h,&s,&v,b ) ;
			 for(o=0;o<a;o++) v *= k ;
			 if (v > 1.0) v = 1.0 ;
			 mc[i*size+j] = hsv2rgb(h,s,v) ;
			}
	}
 if (inversed==1)
	{
	 for(i = 0 ; i < size ; i++)
		for( j=0 ; j < size ; j++ )
			{
			 a = m[i*size+j] ;
			 b = mc[i*size+j] ;
			 a = ((maxl-a) * N) / dl ;
			 rgb2hsv(&h,&s,&v,b ) ;
			 for(o=0;o<a;o++) v *= k ;
			 if (v > 1.0) v = 1.0 ;
			 mc[i*size+j] = hsv2rgb(h,s,v) ;
			}
	}

}




