#include "effectFunctionApophysis_n12.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_n12 :: effectFunctionApophysis_n12()
{
 k = 1.0 ;
 ik = 1.0 ;
}

effectFunctionApophysis_n12 :: ~effectFunctionApophysis_n12()
{
}

void effectFunctionApophysis_n12 :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) { k = 1.0 ; ik = 1.0 ; }
 if (k!= 0.0) ik = 1.0/k ; else ik = 1.0 ;
}

void effectFunctionApophysis_n12 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_n12 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double tx,ty,t,th,t2,t3 ;
 //cout << " void effectFunctionApophysis_n12 :: calculate( planche* pl ) " << endl ;

 tx = k * x0 ;
 ty = k * y0 ;
 t = sqrt(tx*tx+ty*ty) ;
 if (tx != 0.0) th = atan(ty/tx) ; else  th = HALF_PI ;
 t2 = sin(t+th) ;
 t3 = t2 * t2 ;
 *x0p = ifs[capp+8] + ik * t * t2 * t3 ;
 t2 = cos(th-t) ;
 t3 = t2 * t2 ;
 *y0p = ifs[capp+9] + ik * t * t2 * t3 ;
}




