#include "effectFunctionApophysis_n13.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_n13 :: effectFunctionApophysis_n13()
{
 k = 1.0 ;
 ik = 1.0 ;
}

effectFunctionApophysis_n13 :: ~effectFunctionApophysis_n13()
{
}

void effectFunctionApophysis_n13 :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) { k = 1.0 ; ik = 1.0 ; }
 if (k!= 0.0) ik = 1.0/k ; else ik = 1.0 ;
}

void effectFunctionApophysis_n13 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_n13 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double tx,ty,t,th ;
 //double t2 ;
 //cout << " void effectFunctionApophysis_n13 :: calculate( planche* pl ) " << endl ;

 tx = k * x0 ;
 ty = k * y0 ;
 //t2 = rand() * IRAND * PII ;
 t = sqrt(sqrt(tx*tx+ty*ty)) ;
 if (tx != 0.0) th = atan(ty/tx) ; else  th = HALF_PI ;
 //th += t2 ;
 t *= ik ;
 *x0p = ifs[capp+8] + t * cos(th) ;
 *y0p = ifs[capp+9] + t * sin(th) ;
}




