
// je suis oblig de prendre les librairies C++ pour ouvrir un fichier texte :-(
#include <iostream>
#include <fstream>
using namespace std ;
#include <cmath>



#include <qapplication.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qwidget.h>
#include <qnamespace.h> // for NotXorROP
#include <qwmatrix.h>
#include <qpoint.h>
#include <qfile.h>
#include <qtextstream.h>

#include "fenetreImage.h"
#include "constants.h"

fenetreImage :: fenetreImage()
{
 int i ;

 setBackgroundMode( NoBackground ) ;
 iheight = 1 ;
 iwidth = 1 ;
 keyPressed = Qt::Key_A ; // pour initialiser
 for(i=0;i<6;i++) fr[i] = 0 ;
 RectIsChanged = false ;
 sommet = 4 ;
 cote = 4 ;
}

// dessine le cadre de la miniature
void fenetreImage :: drawFrame(QPainter* windowpainter,QPainter* bufferpainter,QPoint* re)
{
 windowpainter->setPen(QColor(0,0,255) ) ;
 bufferpainter->setPen(QColor(0,0,255) ) ;
 windowpainter->drawLine(re[0],re[1] ) ;
 windowpainter->drawLine(re[1],re[2] ) ;
 windowpainter->drawLine(re[2],re[3] ) ;
 windowpainter->drawLine(re[3],re[0] ) ;
 bufferpainter->drawLine(re[0],re[1] ) ;
 bufferpainter->drawLine(re[1],re[2] ) ;
 bufferpainter->drawLine(re[2],re[3] ) ;
 bufferpainter->drawLine(re[3],re[0] ) ;
 windowpainter->drawRect(re[0].x()-3,re[0].y()-3,6,6) ;
 windowpainter->drawRect(re[1].x()-3,re[1].y()-3,6,6) ;
 windowpainter->drawRect(re[2].x()-3,re[2].y()-3,6,6) ;
 windowpainter->drawRect(re[3].x()-3,re[3].y()-3,6,6) ;
 bufferpainter->drawRect(re[0].x()-3,re[0].y()-3,6,6) ;
 bufferpainter->drawRect(re[1].x()-3,re[1].y()-3,6,6) ;
 bufferpainter->drawRect(re[2].x()-3,re[2].y()-3,6,6) ;
 bufferpainter->drawRect(re[3].x()-3,re[3].y()-3,6,6) ;
}

// change de miniature par la touche tabulation
void fenetreImage :: tabRectangle()
{
 QPainter bufferpainter ;
 QPainter windowpainter ;
 int nbIFS = _paralleVector.size() ;

 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 drawFrame(&windowpainter,&bufferpainter,newRect) ;

 indiceParalle++ ;
 if (nbIFS == indiceParalle) indiceParalle = 0 ;
 _paralleVector[indiceParalle].get(rect) ;
 newRect[0] = rect[0] ;
 newRect[1] = rect[1] ;
 newRect[2] = rect[2] ;
 newRect[3] = rect[3] ;
 drawFrame(&windowpainter,&bufferpainter,newRect) ;
 calculateF(newRect) ;

 bufferpainter.end() ;
 windowpainter.end() ;

}

// supprime la miniature courante
void fenetreImage :: supprRectangle()
{
 QPainter bufferpainter ;
 QPainter windowpainter ;
 vector<parallelogramme> :: iterator iv ;
 int nbIFS = _paralleVector.size() ;

 if (nbIFS == 1) return ;

 draw(newRect,true) ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ; 
 nbIFS-- ;
 iv = _paralleVector.begin() ;
 iv += indiceParalle ;
 _paralleVector.erase(iv) ;
 if (indiceParalle == nbIFS ) indiceParalle = 0 ;
 _paralleVector[indiceParalle].get(rect) ;
 newRect[0] = rect[0] ;
 newRect[1] = rect[1] ;
 newRect[2] = rect[2] ;
 newRect[3] = rect[3] ;
 drawFrame(&windowpainter,&bufferpainter,newRect) ;
 calculateF(newRect) ;

 bufferpainter.end() ;
 windowpainter.end() ;

 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
}

// cer une miniature
void fenetreImage :: newRectangle()
{
 QPainter bufferpainter ;
 QPainter windowpainter ;
 parallelogramme* p ;
 int i,j ;


 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 drawFrame(&windowpainter,&bufferpainter,newRect) ;
 bufferpainter.end() ;
 windowpainter.end() ;

 j = iwidth/2 - 50 ;
 i = iheight*100 ;
 i /= iwidth ;
 rect[0].setX(j) ; rect[0].setY(iheight/2) ;
 rect[1].setX(j+100) ; rect[1].setY(iheight/2) ;
 rect[2].setX(j+100) ; rect[2].setY(iheight/2+i) ;
 rect[3].setX(j) ; rect[3].setY(iheight/2+i) ;
 newRect[0] = rect[0] ;
 newRect[1] = rect[1] ;
 newRect[2] = rect[2] ;
 newRect[3] = rect[3] ;

 p = new parallelogramme(rect) ;
 _paralleVector.push_back(*p) ;
 indiceParalle = _paralleVector.size()-1 ;

 calculateF(newRect) ;
 draw(newRect,true) ;

 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
}

// duplique la miniature courante
void fenetreImage :: duplicateRectangle()
{
 QPainter bufferpainter ;
 QPainter windowpainter ;
 QPoint translation ;
 parallelogramme* p ;
 int i,j,k ;

 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 drawFrame(&windowpainter,&bufferpainter,newRect) ;
 bufferpainter.end() ;
 windowpainter.end() ;


 _paralleVector[indiceParalle].get(rect) ;

 j = iwidth/2  ;
 k = (rect[0].x() + rect[2].x())/2 ;
 j -= k ;
 i = iheight/2;
 k = (rect[0].y() + rect[2].y())/2 ;
 i -= k ;
 translation.setX(j) ;
 translation.setY(i) ;
 rect[0] += translation ;
 rect[1] += translation ;
 rect[2] += translation ;
 rect[3] += translation ;
 newRect[0] = rect[0] ;
 newRect[1] = rect[1] ;
 newRect[2] = rect[2] ;
 newRect[3] = rect[3] ;

 p = new parallelogramme(rect) ;
 _paralleVector.push_back(*p) ;
 indiceParalle = _paralleVector.size()-1 ;

 calculateF(newRect) ;
 draw(newRect,true) ;

 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
}

// crer la premire miniature
void fenetreImage :: firstRectangle()
{
 parallelogramme* p ;
 int i,j ;


 j = iwidth/2 - 50 ;
 i = iheight*100 ;
 i /= iwidth ;

 rect[0].setX(j) ; rect[0].setY(iheight/2) ;
 rect[1].setX(j+100) ; rect[1].setY(iheight/2) ;
 rect[2].setX(j+100) ; rect[2].setY(iheight/2+i) ;
 rect[3].setX(j) ; rect[3].setY(iheight/2+i) ;
 newRect[0] = rect[0] ;
 newRect[1] = rect[1] ;
 newRect[2] = rect[2] ;
 newRect[3] = rect[3] ;
 calculateF(newRect) ;
 draw(newRect,true) ;
 p = new parallelogramme(rect) ;
 _paralleVector.push_back(*p) ;
 indiceParalle = 0 ;
}

fenetreImage :: fenetreImage( QPixmap & s )
{
 int i ;

 setBackgroundMode( NoBackground ) ;
 iheight = s.height() ;
 iwidth = s.width() ;
 if (iheight != 0) invHeight = 1.0 / iheight ; else invHeight = 1.0 ;
 if (iwidth != 0) invWidth = 1.0 / iwidth ; else invWidth = 1.0 ;
 keyPressed = Qt::Key_A ; // pour initialiser
 for(i=0;i<6;i++) fr[i] = 0 ;
 RectIsChanged = false ;
 indiceParalle = 0 ;

 resize(iwidth,iheight) ;
 _buffer.resize(iwidth,iheight) ;
 _buffer = s ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
 _source = s.convertToImage () ;

 firstRectangle() ;
}

fenetreImage :: ~fenetreImage()
{
}

int fenetreImage :: coteSelected(QPoint* pA,QPoint* pB,int x, int y)
{
 int xl,xll,yl,yll,dx,dy ;

 if (pA->x() == pB->x())
	{
	 xl = x - pA->x() ;
	 if (pA->y() < pB->y())
		{
		 yl  = pA->y() ;
		 yll = pB->y() ;
		}
		else
		{
		 yl  = pB->y() ;
		 yll = pA->y() ;
		}
	 if ((xl >= -6) && (xl <= 6) && (y>= yl) && (y<=yll)) return true ;
	 	else return false ;
	}
	else
	{
	 if (pA->x() < pB->x())
		{
		 xl  = pA->x() ;
		 xll = pB->x() ;
		 yl  = pA->y() ;
		 yll = pB->y() ;
		}
		else
		{
		 xl  = pB->x() ;
		 xll = pA->x() ;
		 yl  = pB->y() ;
		 yll = pA->y() ;
		}
	 if ((x>=xl) && (x<=xll))
		{
		 dx = xll - xl ;
		 dy = yll - yl ;
		 yl = ((y - yl) * dx - dy * (x-xl))/dx ;
		 if ((yl >= -6) && (yl <= 6)) return true ; else return false ;
		}
		else return false ;
	}
}

// pour la mise au point du dessin de la miniature
void fenetreImage :: fill(QPoint* r)
{
 int in[4] ;
 int yi[4] ;
 int i0,i,x1min,x2min,j,il,dx1,dx2,dy1,dy2,Q1,Q2,ro,g,b ;
 unsigned int couleur ;

 yi[0] = r[0].y() ;
 yi[1] = r[1].y() ;
 yi[2] = r[2].y() ;
 yi[3] = r[3].y() ;
 in[0] = 0 ;
 in[1] = 1 ;
 in[2] = 2 ;
 in[3] = 3 ;
 for(i=0;i<4;i++)
	{
	 il = yi[i] ;
	 i0 = i ;
	 for(j=i+1;j<4;j++)
		{
		 if (yi[j]<il)
			{
			 il = yi[j] ;
			 i0 = j ;
			}
		}
	 yi[i0] = yi[i] ;
	 yi[i] = il ;
	 il = in[i] ;
	 in[i] = in[i0] ;
	 in[i0] = il ;
	}

 cout << endl ;
 for(i=0;i<4;i++) cout << " y[" << i << "] = " << yi[i] << endl ;
 for(i=0;i<4;i++) cout << " i[" << i << "] = " << in[i] << endl ;
 for(i=0;i<4;i++) cout << " (" << r[i].x() << " , " << r[i].y() << " )" << endl ;

 QPainter windowpainter ;
 QPainter bufferpainter ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 //windowpainter.setRasterOp( Qt::NotXorROP ) ;
 //bufferpainter.setRasterOp( Qt::NotXorROP ) ;

 if (yi[0] == yi[1]) // c 'est un rectangle horizontal
	{
	 x1min = r[in[0]].x() ;
	 x2min = r[in[1]].x() ;
	 if (x1min>x2min)
		{
		 i = x1min ;
		 x1min = x2min ;
		 x2min = i ;
		 }
	 //bufferpainter.fillRect(x1min,yi[0],x2min-x1min-1,yi[2]-yi[0],brushing ) ;
	 //windowpainter.fillRect(x1min,yi[0],x2min-x1min-1,yi[2]-yi[0],brushing ) ;
	 //bufferpainter.eraseRect(x0,yi[0],x1-x0-1,yi[2]-yi[0]) ;
	 //windowpainter.eraseRect(x0,yi[0],x1-x0-1,yi[2]-yi[0]) ;
	 il = yi[2] ;
	 for(i= yi[0];i<il;i++)
		for(j=x1min;j<x2min;j++)
			{
			 Q1 = int(fr[0] * j + fr[1] * i + fr[4]) ;
			 Q2 = int(fr[2] * j + fr[3] * i + fr[5]) ;
			 //couleur = (unsigned int) _source.pixel(j,i) ;
			 //couleur = ~couleur ;
			 couleur = (unsigned int) _source.pixel(Q1,Q2) ;
			 ro= ((couleur >> 16) & MASK_BYTE) ;
			 g = ((couleur >> 8) & MASK_BYTE) ;
			 b = (couleur & MASK_BYTE) ;
			 bufferpainter.setPen( QColor(ro,g,b) ) ;
			 windowpainter.setPen( QColor(ro,g,b) ) ;
			 bufferpainter.drawPoint(j,i) ;
			 windowpainter.drawPoint(j,i) ;
			}
	}
	else
	{
	 il = yi[1] ;
	 x1min = r[in[0]].x() ;
	 x2min = r[in[1]].x() ;
	 if (x2min < x1min) x1min = x2min ;
	 x2min = r[in[2]].x() ;
	 i0 = r[in[0]].x() ;
	 if (i0 < x2min) x2min = i0 ;
	 dx1 = r[in[1]].x() - r[in[0]].x() ;
	 dx2 = r[in[2]].x() - r[in[0]].x() ;
	 dy1 = r[in[1]].y() - r[in[0]].y() ;
	 dy2 = r[in[2]].y() - r[in[0]].y() ;
	 x1min = r[in[0]].x() ;
	 x2min = r[in[0]].x() ;
	 if ((x1min < x2min) || ((x1min == x2min) && (dx1*dy2 < dx2*dy1)))
		{
		 // l' arete r[in[0]]-r[in[1]] est  gauche et r[in[0]]-r[in[2]]  droite
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[0];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la deuxime partie
		 il = yi[2] ;
		 dx1 = r[in[3]].x() - r[in[1]].x() ;
		 dy1 = r[in[3]].y() - r[in[1]].y() ;
		 //x1min = r[in[1]].x() ;
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 for(i=yi[1];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 //bufferpainter.drawLine(0,i,x2min,i) ;
			 //windowpainter.drawLine(0,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la dernire partie

		 il = yi[3] ;
		 dx2 = r[in[3]].x() - r[in[2]].x() ;
		 dy2 = r[in[3]].y() - r[in[2]].y() ;
		 //x2min = r[in[2]].x() ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[2];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		}
		else
		{
		 // c 'est le contraire
		 i0  = dx1 ;
		 dx1 = dx2 ;
		 dx2 = i0 ;
		 i   = dy1 ;
		 dy1 = dy2 ;
		 dy2 = i ;
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[0];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la deuxime partie
		 il = yi[2] ;
		 dx2 = r[in[3]].x() - r[in[1]].x() ;
		 dy2 = r[in[3]].y() - r[in[1]].y() ;
		 x2min = r[in[1]].x() ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[1];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la dernire partie
		 il = yi[3] ;
		 dx1 = r[in[3]].x() - r[in[2]].x() ;
		 dy1 = r[in[3]].y() - r[in[2]].y() ;
		 x1min = r[in[2]].x() ;
		 if (dx1 > 0 ) Q1 = dy1 -1 ; else Q1 = 0 ;
		 for(i=yi[2];i<il;i++)
			{
			 bufferpainter.drawLine(x1min,i,x2min,i) ;
			 windowpainter.drawLine(x1min,i,x2min,i) ;
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		}
	}
 bufferpainter.end() ;
 windowpainter.end() ;
}

void fenetreImage :: mousePressEvent( QMouseEvent* event )
{
 int x,y,xl,yl ;
 int bouton ;

 x = event->x() ;
 y = event->y() ;
 bouton = event->button() ;
 if ((keyPressed == Qt::Key_A) && (bouton == LeftButton ))
	{
	 // on cherche l'application slectionne
	}
 if (bouton == LeftButton ) mvtPoint = event->pos() ;

 xl = rect[0].x()-x ;
 yl = rect[0].y()-y ;
 sommet = 4 ;
 if ((xl <= 3) && (xl >= -3) && (yl <= 3) && (yl >= -3))
	{
	 sommet= 0 ;
	}
 xl = rect[1].x()-x ;
 yl = rect[1].y()-y ;
 if ((xl <= 3) && (xl >= -3) && (yl <= 3) && (yl >= -3))
	{
	 sommet= 1 ;
	}
 xl = rect[2].x()-x ;
 yl = rect[2].y()-y ;
 if ((xl <= 3) && (xl >= -3) && (yl <= 3) && (yl >= -3))
	{
	 sommet= 2 ;
	 //cout << " sommet = " << sommet << endl ;
	}
 xl = rect[3].x()-x ;
 yl = rect[3].y()-y ;
 if ((xl <= 3) && (xl >= -3) && (yl <= 3) && (yl >= -3))
	{
	 sommet= 3 ;
	}
 cote = 4 ;
 if (coteSelected(rect,rect+1,x,y)) cote = 0 ;
 if (coteSelected(rect+1,rect+2,x,y)) cote = 1 ;
 if (coteSelected(rect+2,rect+3,x,y)) cote = 2 ;
 if (coteSelected(rect+3,rect,x,y)) cote = 3 ;
}


void fenetreImage :: mouseReleaseEvent( QMouseEvent* event )
{
 mvtPoint = event->pos() ;
 if (RectIsChanged)
	{
	 // ajustement paralllogramme...
	 draw(newRect,true) ;
	 newRect[2] = newRect[3] + (newRect[1]-newRect[0] ) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 // fin du rajustement
	 rect[0] = newRect[0] ;
	 rect[1] = newRect[1] ;
	 rect[2] = newRect[2] ;
	 rect[3] = newRect[3] ;
	 _paralleVector[indiceParalle].set(rect) ;
	 RectIsChanged = false ;

	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	}
}


void fenetreImage :: mouseMoveEvent( QMouseEvent* event )
{
 double tx,ty,n2,pr,n2p,ix,iy,rx,ry ;
 int ax,ay,i,j,k ;

 ax = event->x() - mvtPoint.x() ;
 ay = event->y() - mvtPoint.y() ;

 if (keyPressed == Qt::Key_F1) // translation
	{
	 draw(newRect,true) ;
	 newRect[0].setX(rect[0].x()+ax) ;
	 newRect[0].setY(rect[0].y()+ay) ;
	 newRect[1].setX(rect[1].x()+ax) ;
	 newRect[1].setY(rect[1].y()+ay) ;
	 newRect[2].setX(rect[2].x()+ax) ;
	 newRect[2].setY(rect[2].y()+ay) ;
	 newRect[3].setX(rect[3].x()+ax) ;
	 newRect[3].setY(rect[3].y()+ay) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 RectIsChanged = true ;
	}
 if (keyPressed == Qt::Key_F2) // rotation
	{
	 draw(newRect,true) ;
	 ix = (rect[0].x()+rect[2].x())*0.5 ;
	 iy = (rect[0].y()+rect[2].y())*0.5 ;
	 ty = event->x() - ix ;
	 tx = iy - event->y() ;
	 n2 = sqrt( tx*tx+ty*ty) ;
	 n2p = 1.0 / n2 ;
	 tx *= n2p ;
	 ty *= n2p ;
	 pr = tx * ax + ty * ay ;
	 pr = atan(pr/n2 ) ;
	 tx = cos(pr) ;
	 ty = sin(pr) ;
	 rx = rect[0].x() - ix ;
	 ry = rect[0].y() - iy ;
	 n2  = ix+rx*tx-ry*ty ;
	 n2p = iy+rx*ty+ry*tx ;
	 newRect[0].setX(int(n2) ) ;
	 newRect[0].setY(int(n2p) ) ;
	 rx = rect[1].x() - ix ;
	 ry = rect[1].y() - iy ;
	 n2  = ix+rx*tx-ry*ty ;
	 n2p = iy+rx*ty+ry*tx ;
	 newRect[1].setX(int(n2) ) ;
	 newRect[1].setY(int(n2p) ) ;
	 rx = rect[2].x() - ix ;
	 ry = rect[2].y() - iy ;
	 n2  = ix+rx*tx-ry*ty ;
	 n2p = iy+rx*ty+ry*tx ;
	 newRect[2].setX(int(n2) ) ;
	 newRect[2].setY(int(n2p) ) ;
	 rx = rect[3].x() - ix ;
	 ry = rect[3].y() - iy ;
	 n2  = ix+rx*tx-ry*ty ;
	 n2p = iy+rx*ty+ry*tx ;
	 newRect[3].setX(int(n2) ) ;
	 newRect[3].setY(int(n2p) ) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 RectIsChanged = true ;
	}

 if ((keyPressed == Qt::Key_F3) && (sommet <4)) // aggrandissement
	{
	 //cout << " sommet and Qt::Key_S  = " << sommet << endl ;
	 draw(newRect,true) ;
	 i = sommet+2 ; if (i>3) i -= 4 ;
	 j = sommet+3 ; if (j>3) j -= 4 ;
	 k = sommet+1 ; if (k>3) k -= 4 ;
	 //cout << " sommet and Qt::Key_S  = " << sommet << endl ;
	 //cout << " i " << i << endl ;
	 //cout << " j " << j << endl ;
	 //cout << " k " << k << endl ;
	 tx = rect[j].x() - rect[i].x() ; // x.AB
	 ty = rect[j].y() - rect[i].y() ; // y.AB
	 ix = rect[k].x() - rect[i].x() ; // x.AD
	 iy = rect[k].y() - rect[i].y() ; // y.AD
	 n2 = tx * iy - ty * ix ; // determinant
	 //cout << " v(AB) = " << tx << " , " << ty << endl ;
	 //cout << " v(AD) = " << ix << " , " << iy << endl ;
	 //cout << "    ax = " << ax << " , " << ay << endl ;
	 if (n2 != 0.0 ) n2 = 1.0/n2 ; else n2 = 1.0e10 ;
	 rx = (iy * ax - ix * ay ) * n2 ;
	 ry = (tx * ay - ty * ax ) * n2 ;
	 tx *= rx ;
	 ty *= rx ;
	 ix *= ry ;
	 iy *= ry ;
	 newRect[j].setX(int(rect[j].x()+tx)) ;
	 newRect[j].setY(int(rect[j].y()+ty)) ;
	 newRect[k].setX(int(rect[k].x()+ix)) ;
	 newRect[k].setY(int(rect[k].y()+iy)) ;
	 newRect[sommet].setX(rect[sommet].x()+ax) ;
	 newRect[sommet].setY(rect[sommet].y()+ay) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 RectIsChanged = true ;
	}

 if ((keyPressed == Qt::Key_F4) && (cote <4)) // cisaillement
	{
	 draw(newRect,true) ;
	 i = cote + 1 ; if (i>3) i -= 4 ;
	 newRect[i].setX(rect[i].x()+ax) ;
	 newRect[i].setY(rect[i].y()+ay) ;
	 newRect[cote].setX(rect[cote].x()+ax) ;
	 newRect[cote].setY(rect[cote].y()+ay) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 RectIsChanged = true ;
	}

 if (keyPressed == Qt::Key_F5)  // homothtie
	{
	 draw(newRect,true) ;
	 // coordonnes du centre
	 ix = (rect[0].x()+rect[2].x())*0.5 ;
	 iy = (rect[0].y()+rect[2].y())*0.5 ;
	 tx = event->x() - ix ;
	 ty = iy - event->y() ;
	 rx = mvtPoint.x() - ix ;
	 ry = mvtPoint.y() - iy ;
	 n2 = tx*tx+ty*ty ;
	 n2p =rx*rx+ry*ry+1.0e-6  ;
	 n2 /= n2p ; // rapport des intueurs = k
	 rx = rect[0].x() - ix ;
	 ry = rect[0].y() - iy ;
	 rx *= n2 ;
	 ry *= n2 ;
	 newRect[0].setX(int(ix+rx)) ;
	 newRect[0].setY(int(iy+ry)) ;
	 rx = rect[1].x() - ix ;
	 ry = rect[1].y() - iy ;
	 rx *= n2 ;
	 ry *= n2 ;
	 newRect[1].setX(int(ix+rx)) ;
	 newRect[1].setY(int(iy+ry)) ;
	 rx = rect[2].x() - ix ;
	 ry = rect[2].y() - iy ;
	 rx *= n2 ;
	 ry *= n2 ;
	 newRect[2].setX(int(ix+rx)) ;
	 newRect[2].setY(int(iy+ry)) ;
	 rx = rect[3].x() - ix ;
	 ry = rect[3].y() - iy ;
	 rx *= n2 ;
	 ry *= n2 ;
	 newRect[3].setX(int(ix+rx)) ;
	 newRect[3].setY(int(iy+ry)) ;
	 calculateF(newRect) ;
	 draw(newRect,true) ;
	 RectIsChanged = true ;
	}
}

void fenetreImage :: draw( QPoint* re,bool drawframe )
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int in[4] ;
 int yi[4] ;
 int i0,i,x1min,x2min,j,il,dx1,dx2,dy1,dy2,Q1,Q2,r,g,b ;
 unsigned int couleur ; //,Xim,Yim ;

 // trie dans l'ordre croissant des Y
 yi[0] = re[0].y() ;
 yi[1] = re[1].y() ;
 yi[2] = re[2].y() ;
 yi[3] = re[3].y() ;
 in[0] = 0 ;
 in[1] = 1 ;
 in[2] = 2 ;
 in[3] = 3 ;
 for(i=0;i<4;i++)
	{
	 il = yi[i] ;
	 i0 = i ;
	 for(j=i+1;j<4;j++)
		{
		 if (yi[j]<il)
			{
			 il = yi[j] ;
			 i0 = j ;
			}
		}
	 yi[i0] = yi[i] ;
	 yi[i] = il ;
	 il = in[i] ;
	 in[i] = in[i0] ;
	 in[i0] = il ;
	}

 bufferpainter.begin( &_buffer ) ;
 windowpainter.begin( this ) ;
 QColor croisement ;

 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;

 //cout << " " << endl ;
 //for(i=0;i<4;i++)
//		cout << newRect[i].x() << "  " << newRect[i].y() << endl ;
// cout << " o: " << re[in[0]].x() << "    " << re[in[3]].x() << endl ;

 //if ((yi[0] == yi[1]) && (re[in[0]].x() == re[in[3]].x()))// c 'est un rectangle horizontal

 if (yi[0] == yi[1])// c 'est un parallelogramme horizontal
	{
	 x1min = re[in[0]].x() ;
	 x2min = re[in[1]].x() ;
	 if (x1min>x2min)
		{
		 i = x1min ;
		 x1min = x2min ;
		 x2min = i ;
		 }
	 if (re[in[2]].x() < re[in[3]].x()) dx1 = re[in[2]].x() - x1min ;
	 			 else dx1 = re[in[3]].x() - x1min ;
	 dy1 = re[in[3]].y() - re[in[0]].y() ;
	 //cout << " (dx,dy)" << dx1 << "  " << dy1 << endl ;
	 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
	 //cout << "f" << endl ;
	 //cout << f[0] << " " << f[1] << " " << f[4] << endl ;
	 //cout << f[2] << " " << f[3] << " " << f[5] << endl ;
	 //cout << "fr" << endl ;
	 //cout << fr[0] << " " << fr[1] << " " << fr[4] << endl ;
	 //cout << fr[2] << " " << fr[3] << " " << fr[5] << endl ;
	 //for(i=0;i<4;i++)
	//	cout << re[in[i]].x() << "  " << re[in[i]].y() << endl ;

	 il = yi[2] ;
	 for(i= yi[0];i<il;i++)
	 	{
		 for(j=x1min;j<x2min;j++)
			{
			 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
			 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
			 if (r>=iwidth) r = iwidth - 1 ;
			 if (g>=iheight) g = iheight -1 ;

			 //if ((i == il-1) && (j == x1min))
			//	{
			//	 cout << " il - 1 = " << il -1 << endl ;
			//	 cout << " real = " << fr[2] * j + fr[3] * i + fr[5] << endl ;
			//	 cout << "  r = " << r << " g = " << g << endl ;
			//	}
			 couleur = (unsigned int) _source.pixel(r,g) ;
			 r = ((couleur >> 16) & MASK_BYTE) ;
			 g = ((couleur >> 8) & MASK_BYTE) ;
			 b = (couleur & MASK_BYTE) ;
			 croisement.setRgb(r,g,b) ;
			 bufferpainter.setPen( croisement ) ;
			 windowpainter.setPen( croisement ) ;
			 bufferpainter.drawPoint(j,i) ;
			 windowpainter.drawPoint(j,i) ;
			}
		 Q1 += dx1 ;
		 i0 = Q1 / dy1 ;
		 x1min += i0 ;
		 x2min += i0 ;
		 Q1 -= i0 * dy1 ;
		}
	}
	else
	{
	 //cout << "fr" << endl ;
	 //cout << fr[0] << " " << fr[1] << " " << fr[4] << endl ;
	 //cout << fr[2] << " " << fr[3] << " " << fr[5] << endl ;
	 il = yi[1] ;
	 dx1 = re[in[1]].x() - re[in[0]].x() ;
	 dx2 = re[in[2]].x() - re[in[0]].x() ;
	 dy1 = re[in[1]].y() - re[in[0]].y() ;
	 dy2 = re[in[2]].y() - re[in[0]].y() ;
	 x1min = re[in[0]].x() ;
	 x2min = re[in[0]].x() ;
	 if (dx1*dy2 < dx2*dy1)
		{
		 // l' arete r[in[0]]-r[in[1]] est  gauche et r[in[0]]-r[in[2]]  droite
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[0];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la deuxime partie
		 il = yi[2] ;
		 dx1 = re[in[3]].x() - re[in[1]].x() ;
		 dy1 = re[in[3]].y() - re[in[1]].y() ;
		 //x1min = r[in[1]].x() ;
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 for(i=yi[1];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 //bufferpainter.drawLine(0,i,x2min,i) ;
			 //windowpainter.drawLine(0,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la dernire partie

		 il = yi[3] ;
		 dx2 = re[in[3]].x() - re[in[2]].x() ;
		 dy2 = re[in[3]].y() - re[in[2]].y() ;
		 //x2min = r[in[2]].x() ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[2];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 //cout << " r = " << r << " g = " << g << endl ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		}
		else
		{
		 // c 'est le contraire
		 i0  = dx1 ;
		 dx1 = dx2 ;
		 dx2 = i0 ;
		 i   = dy1 ;
		 dy1 = dy2 ;
		 dy2 = i ;
		 if (dx1 > 0 ) Q1 = dy1 - 1 ; else Q1 = 0 ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[0];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la deuxime partie
		 il = yi[2] ;
		 dx2 = re[in[3]].x() - re[in[1]].x() ;
		 dy2 = re[in[3]].y() - re[in[1]].y() ;
		 //x2min = r[in[1]].x() ;
		 if (dx2 > 0 ) Q2 = -1 ; else Q2 = -dy2 ;
		 for(i=yi[1];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		 // ici commence la dernire partie
		 il = yi[3] ;
		 dx1 = re[in[3]].x() - re[in[2]].x() ;
		 dy1 = re[in[3]].y() - re[in[2]].y() ;
		 //x1min = r[in[2]].x() ;
		 if (dx1 > 0 ) Q1 = dy1 -1 ; else Q1 = 0 ;
		 for(i=yi[2];i<il;i++)
			{
			 //bufferpainter.drawLine(x1min,i,x2min,i) ;
			 //windowpainter.drawLine(x1min,i,x2min,i) ;
			 for(j=x1min;j<x2min;j++)
				{
				 r = int(fr[0] * j + fr[1] * i + fr[4]) ;
				 g = int(fr[2] * j + fr[3] * i + fr[5]) ;
				 if (r<0) r = 0 ;
				 if (g<0) g = 0 ;
				 if (r>=iwidth) r = iwidth - 1 ;
				 if (g>=iheight) g = iheight -1 ;
				 couleur = (unsigned int) _source.pixel(r,g) ;
				 r = ((couleur >> 16) & MASK_BYTE) ;
				 g = ((couleur >> 8) & MASK_BYTE) ;
				 b = (couleur & MASK_BYTE) ;
				 croisement.setRgb(r,g,b) ;
				 bufferpainter.setPen( croisement ) ;
				 windowpainter.setPen( croisement ) ;
				 bufferpainter.drawPoint(j,i) ;
				 windowpainter.drawPoint(j,i) ;
				}
			 Q1 += dx1 ;
			 i0 = Q1 / dy1 ;
			 x1min += i0 ;
			 Q1 -= i0 * dy1 ;
			 Q2 += dx2 ;
			 i0 = Q2 / dy2 ;
			 x2min += i0 ;
			 Q2 -= i0 * dy2 ;
			}
		}
	}
 // dessin du cadre de slection
 if (drawframe)drawFrame(&windowpainter,&bufferpainter,re) ;
 bufferpainter.end() ;
 windowpainter.end() ;
}

// calcule les paramtres de la miniature dfinie par les points re[0], re[1], re[2] et re[3]
void fenetreImage :: calculateF(QPoint* re )
{
 double invDet,u1,v1,u2,v2,Xa,Ya ;

 u1 = re[1].x() - re[0].x() ;
 v1 = re[1].y() - re[0].y() ;
 u2 = re[3].x() - re[0].x() ;
 v2 = re[3].y() - re[0].y() ;
 invDet = u1 * v2 - u2 * v1 ;
 if (invDet != 0.0) invDet = 1.0 / invDet ; else invDet = 0.0 ;
 Xa = re[0].x() ;
 Ya = re[0].y() ;
 // fr = small to big
 fr[0] = v2 * invDet * iwidth ;
 fr[1] = -u2 * invDet * iwidth ;
 fr[2] = -v1 * invDet * iheight ;
 fr[3] = u1 * invDet * iheight ;
 fr[4] = (u2 * Ya - v2 * Xa) * invDet * iwidth ;
 fr[5] = (v1*Xa-u1*Ya) * invDet * iheight ;
}


void fenetreImage :: paintEvent( QPaintEvent* event )
{
 bitBlt( this , 0 , 0 , &_buffer ) ;
}

void fenetreImage :: resizeEvent( QResizeEvent* event)
{
 bitBlt( this , 0 , 0 , &_buffer ) ;
}

void fenetreImage :: imageChanged( QPixmap* img)
{
 iheight = img->height() ;
 iwidth  = img->width() ;
 if (iheight != 0) invHeight = 1.0 / iheight ; else invHeight = 1.0 ;
 if (iwidth != 0) invWidth = 1.0 / iwidth ; else invWidth = 1.0 ;

 resize(iwidth,iheight) ;
 _buffer.resize(iwidth,iheight) ;
 bitBlt( &_buffer , 0 , 0 , img ) ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
 _source = img->convertToImage () ;
 // il faut ensuite dtruire toutes les miniatures de l'ancienne image et en crer une pour
 // la nouvelle image.
 _paralleVector.clear() ;
 keyPressed = Qt::Key_A ; // pour initialiser
 RectIsChanged = false ;
 sommet = 4 ;
 cote = 4 ;

 firstRectangle() ;
}

void fenetreImage :: homothetie(double k)
{
 double ix,iy,rx,ry ;

 draw(newRect,true) ;
 // coordonnes du centre
 ix = (rect[0].x()+rect[2].x())*0.5 ;
 iy = (rect[0].y()+rect[2].y())*0.5 ;
 rx = rect[0].x() - ix ;
 ry = rect[0].y() - iy ;
 rx *= k ;
 ry *= k ;
 newRect[0].setX(int(ix+rx)) ;
 newRect[0].setY(int(iy+ry)) ;
 rx = rect[1].x() - ix ;
 ry = rect[1].y() - iy ;
 rx *= k ;
 ry *= k ;
 newRect[1].setX(int(ix+rx)) ;
 newRect[1].setY(int(iy+ry)) ;
 rx = rect[2].x() - ix ;
 ry = rect[2].y() - iy ;
 rx *= k ;
 ry *= k ;
 newRect[2].setX(int(ix+rx)) ;
 newRect[2].setY(int(iy+ry)) ;
 rx = rect[3].x() - ix ;
 ry = rect[3].y() - iy ;
 rx *= k ;
 ry *= k ;
 newRect[3].setX(int(ix+rx)) ;
 newRect[3].setY(int(iy+ry)) ;

 // rajustement pour avoir un paralllogramme
 newRect[2] = newRect[3] + (newRect[1]-newRect[0] ) ;
 calculateF(newRect) ;
 draw(newRect,true) ;
 //cout <<  " *********" << endl ;
 // fin du rajustement
 rect[0] = newRect[0] ;
 rect[1] = newRect[1] ;
 rect[2] = newRect[2] ;
 rect[3] = newRect[3] ;
 _paralleVector[indiceParalle].set(rect) ;
}

void fenetreImage :: setKeyPressed(int k)
{


 keyPressed =  k ;

 if ( k == Qt::Key_R) fill(rect) ;
 if ( k == Qt::Key_Up)
	{
	 homothetie(1.05) ;
	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	}
 if ( k == Qt::Key_Down)
	{
	 homothetie(0.95) ;
	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	}
 if ( k == Qt::Key_Next)
	{
	 homothetie(0.90) ;
	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	}
 if ( k == Qt::Key_Prior)
	{
	 homothetie(1.10) ;
	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	}
 if ( k == Qt::Key_N) newRectangle() ;
 if ( k == Qt::Key_D) duplicateRectangle() ;
 if ( k == Qt::Key_P) printParalleVector() ;
 if ( k == Qt::Key_Tab ) tabRectangle() ;
 if ( k == Qt::Key_Delete ) supprRectangle() ;
}

void fenetreImage :: saveIFS(QString name)
{
 int n,i ;
 QPoint r[4] ;
 QString nb ;

 QFile file( name+".ifs" ) ;
 if (file.open( IO_WriteOnly ))
	{
	 QTextStream stream( &file ) ;
	 n = _paralleVector.size() ;
	 stream << "[number of parallelogrammes]" << endl ;
	 stream <<  n << endl ;
	 stream << "[coordinates]" << endl ;
	 for(i=0;i<n;i++)
		{
		 _paralleVector[i].get(r) ;
		 stream << nb.setNum(r[0].x()) << endl ;
		 stream << nb.setNum(r[0].y()) << endl ;
		 stream << nb.setNum(r[1].x()) << endl ;
		 stream << nb.setNum(r[1].y()) << endl ;
		 stream << nb.setNum(r[2].x()) << endl ;
		 stream << nb.setNum(r[2].y()) << endl ;
		 stream << nb.setNum(r[3].x()) << endl ;
		 stream << nb.setNum(r[3].y()) << endl ;
		}
	 file.close() ;
	}
}

void fenetreImage :: loadIFS(QString name)
{
 QPainter bufferpainter ;
 QPainter windowpainter ;
 int n,i,j ;
 parallelogramme* p ;
 QPoint r[4] ;
 char ch[32] ;

 cout << " QString name = " << name << endl ;

 ifstream entreeText ( name.latin1()  , ios::in ) ;
 if (entreeText)
	{
	 entreeText.getline(ch,32) ; // pour [number of parallelogrammes]
	 //cout << ch << endl ;
	 entreeText.getline(ch,32) ;
	 cout << ch << endl ;
	 n = atoi(ch) ;
	 if ((n<=1) || (n>1000))
		{
		 entreeText.close() ;
		 cout << " problem :: n = " << n << endl ;
		 return ;
		}

	 //drawFrame(&windowpainter,&bufferpainter,newRect) ;
	 //draw(newRect) ;

	 _paralleVector.clear() ;

	 _buffer.convertFromImage(_source) ;
	 bitBlt( this , 0 , 0 , &_buffer ) ;
	 //cout << "_paralleVector.size() =  " << _paralleVector.size() << endl ;
	 entreeText.getline(ch,32) ;  // pour [coordinates]
	 for(i=0;i<n;i++)
		{
		 for(j=0;j<4;j++)
			{
			 entreeText.getline(ch,32) ;
			 r[j].setX(atoi(ch)) ;
			 entreeText.getline(ch,32) ;
			 r[j].setY(atoi(ch)) ;
			}
		 p = new parallelogramme(r) ;
		 _paralleVector.push_back(*p) ;
		 calculateF(r) ;
		 draw(r,false) ;
		}
	 indiceParalle = 0 ;
	 _paralleVector[indiceParalle].get(rect) ;
	 newRect[0] = rect[0] ;
	 newRect[1] = rect[1] ;
	 newRect[2] = rect[2] ;
	 newRect[3] = rect[3] ;
	 calculateF(newRect) ;
	 bufferpainter.begin( &_buffer ) ;
	 windowpainter.begin( this ) ;
	 windowpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
	 bufferpainter.setRasterOp( Qt::NotXorROP  /*Qt::CopyROP*/  ) ;
	 drawFrame(&windowpainter,&bufferpainter,newRect) ;
	 bufferpainter.end() ;
	 windowpainter.end() ;
	 emit signalIFSchanged( &_paralleVector,iheight,iwidth ) ;
	 entreeText.close() ;
	}
}

/*
void fenetreImage :: keyPressEvent( QKeyEvent* event )
{
 keyPressed = event->key() ;
 cout << " keyPressed = " << keyPressed << endl ;
}

void fenetreImage :: keyReleaseEvent( QKeyEvent* event )
{
 keyPressed = Qt::Key_A ; // pour initialiser
}
*/

void fenetreImage :: printParalleVector()
{
 int i,nbIFS ;

 nbIFS = _paralleVector.size() ;
 cout << endl ;
 cout << "nbIFS = " <<  nbIFS << endl ;
 cout << "indiceParalle = " <<  indiceParalle << endl ;
 for(i=0;i<nbIFS;i++) _paralleVector[i].print() ;
}

void fenetreImage ::  slotBof()
{
}




